<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

if(!empty($element["behaviors"])){
	foreach($element["behaviors"] as $behavior){
		$bv_path = __DIR__.'/behaviors/'.$behavior;
		if(str_contains($behavior, ".")){
			$bv_path = __DIR__.'/chronoforms/'.$element["type"].'/'.$element["name"].'/behaviors/'.explode(".", $behavior)[1];
		}
		// echo $bv_path;
		if(file_exists($bv_path."/output.php")){
			require($bv_path."/output.php");
		}
	}

	if(isset($element["settings"]["disabled"]) && !empty($element["settings"]["disabled"])){
		return;
	}
}

$css = ["box-sizing: border-box"];
if(!empty($element["styles"])){
	foreach($element["styles"] as $style_id){
		$style = $elements[$style_id];
		foreach($style["style"]["css"]["all"] as $property => $value){
			if(($property != 'output') && strlen($value) > 0){
				$css[] = $property.":".$value;
			}
		}
	}
}
$css = implode(";", $css).";";

$view_path = __DIR__.'/layouts/'.$element["type"].'/'.$element["name"];

$json_path = $view_path . "/info.json";
if(file_exists($json_path)){
	$myfile = fopen($json_path, "r");
	$data = fread($myfile, filesize($json_path));
	fclose($myfile);
	$json = json_decode($data, true);

	if(!empty($json["premium"]) && !$this->isAdmin() && !$this->validated(true)){
		ChronoSession::setFlash("warning", "Using ".$json["title"]." on the frontend is limited to premium installs, please support us with a purchase.");
		return;
	}
	
	ob_start();
	require($view_path."/output.php");
	$output = ob_get_clean();
	
	echo $output;
}
?>