<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

$elements = [
	1 => ["id" => 1, "type" => "page"],
	2 => ["id" => 2, "parent" => 1, "section" => "body", "name" => "body", "type" => "elements", "label" => "Email Body", "styles" => ["3"]],
	3 => ["id" => 3, "parent" => 2, "section" => "views", "name" => "style", "type" => "elements", "label" => "Email Body Default Style", "selector" => ".cm_body_style", 
		"style" => ["css" => ["all" => ["background-color" => "#f2f2f2", "padding" => "1em", "font-size" => "16px"]]]
	],
	4 => ["id" => 4, "parent" => 2, "section" => "views", "name" => "style", "type" => "elements", "label" => "Centered Container Style", "selector" => ".cm_centered_container_style", 
		"style" => ["css" => ["all" => ["display" => "block", "width" => "100%", "max-width" => "600px", "margin" => "auto"]]]
	],
	5 => ["id" => 5, "parent" => 2, "section" => "views", "name" => "style", "type" => "elements", "label" => "Inner Container Style", "selector" => ".cm_inner_container_style", 
		"style" => ["css" => ["all" => ["background-color" => "#ffffff", "padding" => "1em"]]]
	],
	13 => ["id" => 13, "parent" => 2, "section" => "views", "name" => "style", "type" => "elements", "label" => "Header Container Style", "selector" => ".cm_header_container_style", 
		"style" => ["css" => ["all" => ["background-color" => "lightslategrey", "color" => "white"]]]
	],
	6 => ["id" => 6, "parent" => 2, "section" => "views", "name" => "container", "type" => "elements", "label" => "Centered Content", "styles" => ["4"]],
	7 => ["id" => 7, "parent" => 6, "section" => "views", "name" => "container", "type" => "elements", "label" => "Header", "styles" => ["5", "13"]],
	8 => ["id" => 8, "parent" => 6, "section" => "views", "name" => "container", "type" => "elements", "label" => "Middle", "styles" => ["5"]],
	9 => ["id" => 9, "parent" => 6, "section" => "views", "name" => "container", "type" => "elements", "label" => "Footer", "styles" => ["5"]],
	10 => ["id" => 10, "parent" => 7, "section" => "views", "name" => "message", "type" => "elements", "label" => "Header Content", "text" => '<h3>Domain.com</h3>'],
	11 => ["id" => 11, "parent" => 8, "section" => "views", "name" => "message", "type" => "elements", "label" => "Middle Content", "text" => '{email:body}'],
	12 => ["id" => 12, "parent" => 9, "section" => "views", "name" => "message", "type" => "elements", "label" => "Footer Content", "text" => '<p style="text-align: center;"><span>© 2025 </span>Domain.com</p>'],
];

$pages_ids = [1];
$abort = false;
$active_page_id = 1;
$active_section = "body";

if($this->isPost){
	// Chrono::pr($this->data);
	if(ChronoApp::$instance->DataExists("form_data")){
		$tot = [];
		foreach($this->data["form_data"] as $ch){
			parse_str($ch, $d);
			$tot = array_replace_recursive($tot, $d);
		}
		unset($this->data["form_data"]);
		$this->data = array_merge($this->data, $tot);
	}

	if(!empty($this->data("elements"))){
		$elements = $this->data("elements");
	}

	$DisplayElements = function ($elements_by_parent, $parent_id, $section) use (&$DisplayElements, $elements, $pages_ids, &$active_section, &$abort) {
		static $current_page_id, $current_page_section;
		if(in_array($parent_id, $pages_ids)){
			$current_page_id = $parent_id;
			$current_page_section = $section;
		}
	
		$children = !empty($elements_by_parent[$parent_id]) ? $elements_by_parent[$parent_id] : [];
		$current_section = $active_section;
	
		foreach ($children as $ke => $element) {
			if(isset($element["settings"]["disabled"]) && !empty($element["settings"]["disabled"])){
				continue;
			}
			if(!empty($element["acl"])){
				if(ChronoApp::isJoomla() && !in_array($element["acl"], $this->user()->getAuthorisedViewLevels())){
					continue;
				}
			}
			if ($element["section"] == $section) {
				require(__DIR__ . "/layouts.display_element.php");
				
				// check this again because it can be set now by run_conditions
				if(isset($element["settings"]["disabled"]) && !empty($element["settings"]["disabled"])){
					continue;
				}
	
				if($abort == true){
					break;
				}
			}
		}
	};

	$elements_by_parent = [];
	foreach ($elements as $element) {
		if ($element["type"] != "page") {
			$elements_by_parent[$element["parent"]][] = $element;
		}
	}

	ob_start();
	$DisplayElements($elements_by_parent, $active_page_id, $active_section);
	$this->data["template"] = ob_get_clean();

	$this->data["created"] = gmdate("Y-m-d H:i:s", time());

	ChronoPage::Save(CMLayoutsModel::instance());
	// Chrono::pr($this->data);
}else{
    if(empty($this->data("id")) && !$this->validated(true)){
        $count = CMLayoutsModel::instance()->Select(count:true);
        if($count >= 2){
            ChronoSession::setFlash("warning", "The free version supports only two mail layouts.");
            $this->redirect($this->extension_url."&action=layouts.index");
        }
    }
}

Chrono::loadAsset("/assets/layout_builder.min.css");
Chrono::loadAsset("/assets/layout_builder.min.js");
// Chrono::loadAsset("/assets/nui.tinymce.min.js");
Chrono::loadAsset("/assets/ace.min.js");

$row =  CMLayoutsModel::instance()->Select(conditions:[['id', "=", ChronoApp::$instance->data("id")]], single: true);
if (!is_null($row) && !empty($row["elements"])) {
	$elements = $row["elements"];
}else{
	$row["elements"] = $elements;
}

ChronoApp::$instance->MergeData($row);
// Chrono::pr($row);

$views = [];
$views_path = __DIR__ . '/layouts/elements/';
$scan = scandir($views_path);

foreach ($scan as $folder) {
	if (is_dir($views_path . $folder) && !str_contains($folder, ".")) {
		$path = $views_path . $folder . "/info.json";
		if(!file_exists($path)){
			ChronoSession::setFlash("error", "View json file not found:".$folder);
			continue;
		}
		$myfile = fopen($path, "r") or die("Unable to open file $path");
		$data = fread($myfile, filesize($path));
		fclose($myfile);
		$view = json_decode($data);
		$view->name = $folder;
		$views[$view->group][] = $view;
	}
}

$loadElements = function ($elements, $pid, $section) use(&$loadElements) {
	foreach ($elements as $element) {
		if ($element["type"] != "page") {
			if ($element["parent"] == $pid && $element["section"] == $section) {
				$element["pid"] = $pid;
				ChronoApp::$instance->MergeData($element);
				require(__DIR__ . "/layouts.load_element.php");
			}
		}
	}
};

// Chrono::addHeaderTag('<script src="'.$this->root_url.'media/vendor/tinymce/tinymce.min.js?nocache'.'"></script>');
Chrono::loadEditor();
?>
<script>
	function saveform(){
		<?php
			if(empty(Chrono::getVal($this->settings, "max_field_mode", ""))){
				echo "return";
			}
		?>
		form = document.querySelector("form.nui.form")

		let formData = new FormData(form)
		let arr = new FormData(undefined)
		let fi = 1
		let tot = 1

		// console.log(Array.from(formData.keys()).length)

		formData.keys().forEach(key => {
			if(arr.has(key)){
				return
			}
			// console.log(key, formData.getAll(key))
			// arr[key] = formData.getAll(key)
			value = formData.getAll(key)
			if(value.length > 1){
				value.forEach(v => {
					arr.append(key, v)
				})
				// arr.set(key, new Blob(value), 'blob')
			}else{
				arr.set(key, value)
			}
			// arr.set(key, value)
			
			form.querySelector('[name="'+key+'"]').disabled = true
			fi++
			tot++
			if(fi == 200){
				// console.log(arr)
				values = new URLSearchParams(arr);
				values = values.toString()
				// console.log(values)
				form_data = Nui.Core.create_element('<textarea name="form_data[]" style="display:none;" class="form_data"></textarea>')
				form.append(form_data)
				form_data.value = values

				fi = 1
				arr = new FormData(undefined)
			}
		})

		if(fi  > 1){
			// console.log(arr)
			values = new URLSearchParams(arr);
			values = values.toString()
			// console.log(values)
			form_data = Nui.Core.create_element('<textarea name="form_data[]" style="display:none;" class="form_data"></textarea>')
			form.append(form_data)
			form_data.value = values

			fi = 1
			arr = new FormData(undefined)
		}
	}

	function quicksaveform(field){
		field.closest("form").classList.add("loading");

		saveform()
		
		let postBody = new FormData(field.closest("form"))

		if(field.closest("form").querySelectorAll(".form_data")){
			field.closest("form").querySelectorAll(".form_data").forEach(form_data => {
				form_data.remove()
			})
			field.closest("form").querySelectorAll("[name]").forEach(input => {
				input.disabled = false
			})
		}
		
		
		const xhttp = new XMLHttpRequest();

		xhttp.addEventListener("readystatechange", (e) => {
			if (e.target.readyState == 4 && e.target.status == 200) {
				field.closest("form").classList.remove("loading");
				Nui.Toast.show({ "message": "Form Saved", "color": "green", "position": "bottom right" })
			}
		})

		xhttp.open("POST", field.closest("form").getAttribute("action"));
		xhttp.send(postBody);
	}
</script>
<form class="nui form" action="<?php echo ChronoApp::$instance->current_url; ?>" method="post" enctype="multipart/form-data" accept-charset="UTF-8" onsubmit="saveform()" <?php if(Chrono::getVal($this->settings, "label_fieldname", "1") == "1"): ?>data-autofieldname="1"<?php endif; ?>>
	<?php
	$buttons = [];
	
	$buttons[] = new MenuButton(name: "save", title: "Save", icon: "floppy-disk", color: "blue");
	
	if (strlen(ChronoApp::$instance->Data("id")) > 0){
		$buttons[] = new MenuButton(name: "quick_save", title: "Quick Save", icon: "check", color: "blue", params:'onclick="quicksaveform(this)"', type:"button");
	}
	$title = "New Layout";
	if(!empty($row["id"])){
		$title = "<span class='nui smaller'>".$row["title"]."</span>";
	}
	$buttons[] = new MenuButton(name: "close", link: true, title: "Close", icon: "xmark", color: "red", url: "action=layouts.index");
	
	new MenuBar(title: $title, buttons: $buttons);

	new FormField(name: "id", label: "ID", type: "hidden");
	?>

	<div class="equal fields">
		<?php new FormField(name: "title", label: "Title", value:"Layout--".gmdate("d-m-Y--H:i:s"), code: 'data-validations=\'{"rules":[{"type":"required","prompt":"This field is required."}]}\''); ?>
		<?php
			new FormField(name: "published", label: "Published", type: "select", hint:"Form is open for public ?", options: [
				new Option(text: "Yes", value: "1"),
				new Option(text: "No", value: "0"),
			]);
		?>
	</div>
	
	<div>
		<div class="nui flex tabular menu top attached">
			<div class="active item" data-tab="designer">Designer</div>
			<div class="item" data-tab="settings">Settings</div>
		</div>
		<div class="nui segment flex white spaced bordered bottom attached tab" data-tab="designer">
			<div style="min-width:35%">
				<div class="nui flex vertical spaced form_designer" data-url="<?php echo ChronoApp::$instance->extension_url; ?>&output=component">
					<?php
						$pagegroups = [""];
						foreach ($elements as $element){
							if ($element["type"] == "page"){
								if(!empty($element["pagegroup"]) && !in_array($element["pagegroup"], $pagegroups)){
									$pagegroups[] = $element["pagegroup"];
								}
							}
						}
					?>
					<?php foreach ($elements as $element) : ?>
						<?php if ($element["type"] == "page") : ?>
							<?php $pid = $element["id"]; ?>

							<div class="nui page_box">
								<input type="hidden" name="elements[<?php echo $pid; ?>][id]" value="<?php echo $pid; ?>">
								<input type="hidden" name="elements[<?php echo $pid; ?>][type]" value="page">
								<?php new FormField(name: "elements[".$pid."][minimized]", type: "hidden"); ?>

								<div class="nui flex tabular menu top attached navtabs" data-parent='[data-tab="designer"]'>
									<div class="active item hide_minimized" data-tab="body"><?php echo Chrono::ShowIcon("bars-staggered"); ?>Layout Design</div>
									<div class="item hide_minimized" data-tab="elements"><?php echo Chrono::ShowIcon("boxes-stacked"); ?>Design Elements</div>
								</div>
								<div class="nui segment spaced bordered rounded bottom attached tab flex vertical form_page hide_minimized" data-pid="<?php echo $pid; ?>" data-section="body" data-tab="body" data-hint="Drag Views or Actions from the right side."><?php $loadElements($elements, $pid, "body"); ?></div>
								
								<div class="nui segment spaced bordered rounded bottom attached tab flex vertical form_page hide_minimized" data-tab="elements">
									<div class="nui flex vertical p1 divided rounded accordion">
										<?php foreach(["Static"] as $group): ?>
											<div class="item <?php if($group == "Static"){ echo "active"; } ?> nui pv1">
												<div class="title nui bold">
													<i class="dropdown icon"></i>
													<?php echo $group; ?>
												</div>
												<div class="content nui flex vertical spaced p0">
													<?php foreach ($views[$group] as $view) : ?>
														<div class="nui label rounded colored teal inverted link draggable original_item" data-type="elements" data-name="<?php echo $view->name; ?>"><?php echo Chrono::ShowIcon($view->icon); ?><?php echo $view->title; ?><?php echo (!empty($view->premium) ? Chrono::ShowIcon("dollar-sign nui black") : "") ?></div>
													<?php endforeach; ?>
												</div>
											</div>
										<?php endforeach; ?>
									</div>
								</div>
							</div>
						<?php endif; ?>
					<?php endforeach; ?>
				</div>
			</div>

			<div style="min-width:65%">
				<div class="nui flex tabular menu top attached">
					<div class="item active hide_minimized" data-tab="preview"><?php echo Chrono::ShowIcon("display"); ?>Layout Preview</div>
					<div class="item hide_minimized" data-tab="output"><?php echo Chrono::ShowIcon("code"); ?>Layout Output</div>
				</div>
				<div class="nui segment spaced bordered rounded bottom attached tab flex vertical form_page hide_minimized" data-tab="preview">
					
				</div>
				<div class="nui segment spaced bordered rounded bottom attached tab flex vertical form_page hide_minimized" data-tab="output">
					<?php new FormField(name: "template", type: "textarea", rows:30, label: "Last Saved Layout Code", hint:"Auto generated, can not be changed here."); ?>
				</div>
			</div>

			<div class="nui xsegment flex vertical xbordered rounded white tools_box sticky" style="top:75px">
				
			</div>

		</div>
		<div class="nui segment form white bordered rounded bottom attached tab" data-tab="settings">
		
			<fieldset class="nui segment form bordered rounded">
				<legend class="nui bold large label grey rounded">General</legend>
				<?php new FormField(name: "params[apply_extensions]", type:"select", label: "Extensions Names", multiple:true, value:["com_users", "com_chronoforms8"], code:"data-additions='1' data-separators=','", hint:"Comma separated list of extensions names to listen to their emails and apply the layout"); ?>
				<?php new FormField(name: "params[info]", type: "textarea", rows:2, label: "Description", hint:"Short description for the form to appear in the forms manager"); ?>
			</fieldset>

			<fieldset class="nui segment form bordered rounded">
				<legend class="nui bold large label grey rounded">Locales</legend>
				<?php //new FormField(name: "params[locales][default]", label: "Default Language Code", value:"", hint:"The default language code of your web site."); ?>
				<?php foreach(["n" => ""] + (!empty($row["params"]["locales"]) ? $row["params"]["locales"]["lang"] : []) as $k => $lang): ?>
					<div class="nui form clonable locales" data-selector=".clonable.locales" data-cloner=".locales-cloner" data-key="<?php echo $k; ?>">
						<?php
							new FormField(name: "params[locales][lang][".$k."]", label: "Language Code", value:"", hint:"The language code in your web site.");
							new FormField(name: "params[locales][strings][".$k."]", type:"textarea", rows:10, label: "Language Strings", value:"", hint:"The language translation strings in this format:
								LANGUAGE_STRING=String translated in this Language
								Call language strings in your form using {l:LANGUAGE_STRING}");
						?>
						<button type="button" class="nui button red iconed block remove-clone"><?php echo Chrono::ShowIcon("xmark"); ?>Remove Language</button>
						<div class="nui divider block"></div>
					</div>
				<?php endforeach; ?>
				<button type="button" class="nui button blue iconed locales-cloner"><?php echo Chrono::ShowIcon("plus"); ?>Add Language</button>
			</fieldset>
		</div>
	</div>

</form>