<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

$sort = Chrono::getVal($this->settings, "index_sort", "id asc");
$rows = CMLayoutsModel::instance()->Select(order_by:true, order:$sort);
?>
<form class="nui form" action="<?php echo ChronoApp::$instance->current_url; ?>" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
	<?php
	new MenuBar(title: "Mail Layouts", buttons: [
		new MenuButton(link: true, url: "action=layouts.edit", title: "New", color:"blue bordered", icon:"plus"),
		new MenuButton(action:true, title: "Copy", icon:"copy", color:"grey bordered", url:"action=layouts.copy"),
		// new MenuButton(action:true, title: "Backup", icon:"download", color:"grey bordered", url:"action=layouts.backup&output=component"),
		// new MenuButton(link: true, url: "action=layouts.restore", title: "Restore", color:"grey bordered", icon:"upload"),
		new MenuButton(action:true, title: "Delete", icon:"trash", color:"red bordered", url:"action=layouts.delete"),
	]);
	?>

	<?php
	new DataTable($rows, [
		new TableColumn(selector:true, name:"id"),
		new TableColumn(name:"title", title:"Layout", expand:true, sortable:true, func:function($row){
			$text = '<a href="'.ChronoApp::$instance->extension_url.'&action=layouts.edit&id='.$row["id"].'"><strong>'.$row["title"].'</strong></a>';
			if(!empty($row["params"]["info"])){
				$text .= '<br><small>'.nl2br($row["params"]["info"]).'</small>';
			}
			return $text;
			// return '<a href="'.ChronoApp::$instance->extension_url.'&action=edit&id='.$row["id"].'">'.$row["title"].'</a>'.' ('.$row["alias"].')';
		}),
		new TableColumn(name:"published", title:Chrono::l("Enabled"), sortable:true, class:"text-center", func:function($row){
			if($row["published"] == "1"){
				return '<a href="'.ChronoApp::$instance->extension_url.'&action=layouts.toggle&id='.$row["id"].'&field=published&value=0">'.Chrono::ShowIcon("check nui green").'</a>';
			}else{
				return '<a href="'.ChronoApp::$instance->extension_url.'&action=layouts.toggle&id='.$row["id"].'&field=published&value=1">'.Chrono::ShowIcon("xmark nui red").'</a>';
			}
		}),
		new TableColumn(name:"id", title:"ID", sortable:true),
	]);
	?>
</form>