<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

$pages_ids = [1];
$abort = false;
$active_page_id = 1;
$active_section = "body";

if($this->isPost){
	if(ChronoApp::$instance->DataExists("form_data")){
		$tot = [];
		foreach($this->data["form_data"] as $ch){
			parse_str($ch, $d);
			$tot = array_replace_recursive($tot, $d);
		}
		unset($this->data["form_data"]);
		$this->data = array_merge($this->data, $tot);
	}

	if(!empty($this->data("elements"))){
		$elements = $this->data("elements");
	}

	$DisplayElements = function ($elements_by_parent, $parent_id, $section) use (&$DisplayElements, $elements, $pages_ids, &$active_section, &$abort) {
		static $current_page_id, $current_page_section;
		if(in_array($parent_id, $pages_ids)){
			$current_page_id = $parent_id;
			$current_page_section = $section;
		}
	
		$children = !empty($elements_by_parent[$parent_id]) ? $elements_by_parent[$parent_id] : [];
		$current_section = $active_section;
	
		foreach ($children as $ke => $element) {
			if(isset($element["settings"]["disabled"]) && !empty($element["settings"]["disabled"])){
				continue;
			}
			if(!empty($element["acl"])){
				if(ChronoApp::isJoomla() && !in_array($element["acl"], $this->user()->getAuthorisedViewLevels())){
					continue;
				}
			}
			if ($element["section"] == $section) {
				require(__DIR__ . "/layouts.display_element.php");
				
				// check this again because it can be set now by run_conditions
				if(isset($element["settings"]["disabled"]) && !empty($element["settings"]["disabled"])){
					continue;
				}
	
				if($abort == true){
					break;
				}
			}
		}
	};

	$elements_by_parent = [];
	foreach ($elements as $element) {
		if ($element["type"] != "page") {
			$elements_by_parent[$element["parent"]][] = $element;
		}
	}

	ob_start();
	$DisplayElements($elements_by_parent, $active_page_id, $active_section);
	$template = ob_get_clean();

    echo $template;
}