<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

if($this->isPost){
	ChronoPage::Save(CMListsModel::instance());
}else{
    if(empty($this->data("id")) && !$this->validated(true)){
        $count = CMListsModel::instance()->Select(count:true);
        if($count >= 2){
            ChronoSession::setFlash("warning", "The free version supports only two mailing lists.");
            $this->redirect($this->extension_url."&action=lists.index");
        }
    }
}

$row =  CMListsModel::instance()->Select(conditions:[['id', "=", ChronoApp::$instance->data("id")]], single: true);

ChronoApp::$instance->MergeData($row);
?>
<form class="nui form" action="<?php echo ChronoApp::$instance->current_url; ?>" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
	<?php
	$buttons = [];
	
	$buttons[] = new MenuButton(name: "save", title: "Save", icon: "floppy-disk", color: "blue");
	
	$title = "New Mailing List";
	if(!empty($row["id"])){
		$title = "<span class='nui smaller'>".$row["title"]."</span>";
	}
	$buttons[] = new MenuButton(name: "close", link: true, title: "Close", icon: "xmark", color: "red", url: "action=lists.index");
	
	new MenuBar(title: $title, buttons: $buttons);

	new FormField(name: "id", label: "ID", type: "hidden");
	?>

	<div class="equal fields">
		<?php new FormField(name: "title", label: "Title", value:"Mailing List-".gmdate("d-m-Y--H:i:s"), code: 'data-validations=\'{"rules":[{"type":"required","prompt":"This field is required."}]}\''); ?>
		<?php
			new FormField(name: "published", label: "Published", type: "select", hint:"Form is open for public ?", options: [
				new Option(text: "Yes", value: "1"),
				new Option(text: "No", value: "0"),
			]);
		?>
	</div>
    <?php new FormField(name: "description", type: "textarea", rows:5, label: "Description", hint:"List description"); ?>

</form>