<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

$sort = Chrono::getVal($this->settings, "logs_index_sort", "id asc");
$rows = CMLogsModel::instance()->Select(order_by:true, order:$sort, paging:true);
$count = CMLogsModel::instance()->Select(count:true);
if((int)$this->data("start_at") >= 20 && !$this->validated(true)){
    ChronoSession::setFlash("warning", "You can view the latest 20 mail logs only on the free version.");
    $this->redirect($this->extension_url."&action=logs.index&start_at=0");
}
?>
<form class="nui form" action="<?php echo ChronoApp::$instance->current_url; ?>" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
	<?php
	new MenuBar(title: "Mail Logs", buttons: [
		new MenuButton(action:true, title: "Delete", icon:"trash", color:"red bordered", url:"action=logs.delete"),
	]);
	?>

	<?php
	new DataTable($rows, [
		new TableColumn(selector:true, name:"id"),
		new TableColumn(name:"created", title:"Time", expand:true, sortable:true, func:function($row){
            return '<a href="'.ChronoApp::$instance->extension_url.'&action=logs.view&id='.$row["id"].'">'.$row["created"].'</a>';
		}),
        new TableColumn(name:"recipients", title:"Recipients", expand:true, sortable:true, func:function($row){
            $list = [];
            foreach($row["recipients"] as $recipient){
                if(is_array($recipient)){
                    $list[] = $recipient[0]." (".$recipient[1].")";
                }else{
                    $list[] = $recipient;
                }
            }
            return implode("<br>", $list);
		}),
        new TableColumn(name:"subject", title:"Subject", expand:true, sortable:true, func:function($row){
            return $row["subject"];
		}),
        new TableColumn(name:"extension", title:"Extension", expand:true, sortable:true, func:function($row){
            return '<div class="nui label slate keepwords">'.$row["extension"].'</div>';
		}),
		new TableColumn(name:"status", title:Chrono::l("Sent"), sortable:true, class:"text-center", func:function($row){
			if($row["status"] == "1"){
				return Chrono::ShowIcon("check nui green");
			}else{
				return Chrono::ShowIcon("xmark nui red");
			}
		}),
		new TableColumn(name:"id", title:"ID", sortable:true),
	], count:$count, limit:20);
	?>
</form>