<?php
/**
 * ChronoMails
 * Copyright (c) 2025 ChronoEngine.com, All rights reserved.
 * Author: (ChronoEngine.com Team)
 * license: GNU General Public License version 2 or later; see LICENSE.txt
 * Visit http://www.ChronoEngine.com for regular updates and information.
 **/
defined('_JEXEC') or die('Restricted access');

$row = CMLogsModel::instance()->Select(conditions: [['id', "=", ChronoApp::$instance->data("id")]], single: true);

new MenuBar(title: $row["subject"], buttons: [
	new MenuButton(link: true, title: "Close", icon: "xmark", color: "red", url: "action=logs.index"),
]);
?>
<table class="nui table white block bordered rounded celled definition">
	<tbody>
		<tr>
			<td class="collapsing">ID</td>
			<td><?php echo $row["id"]; ?></td>
		</tr>
		<tr>
			<td class="collapsing">Time</td>
			<td><?php echo $row["created"]; ?></td>
		</tr>
		<tr>
			<td class="collapsing">Subject</td>
			<td><?php echo $row["subject"]; ?></td>
		</tr>
		<tr>
			<td class="collapsing">Recipients</td>
			<td>
				<?php
					$list = [];
					foreach($row["recipients"] as $recipient){
						if(is_array($recipient)){
							$list[] = $recipient[0]." (".$recipient[1].")";
						}else{
							$list[] = $recipient;
						}
					}
					echo implode("<br>", $list);
				?>
			</td>
		</tr>
		<tr>
			<td class="collapsing">Status</td>
			<td>
			<?php 
				if($row["status"] == "1"){
					echo '<div class="nui label green">Sent</div>';
				}else{
					echo '<div class="nui label red">Failed</div>';
				}
			?>
			</td>
		</tr>
		<tr>
			<td class="collapsing">Body</td>
			<td>
			<?php
				if($row["headers"]["ContentType"] == "text/plain" && !str_contains($row["body"], '</div>')){
					echo nl2br($row["body"]);
				}else{
					echo $row["body"];
				}
			?>
			</td>
		</tr>
		<tr>
			<td class="collapsing">Extension</td>
			<td><?php echo '<div class="nui label slate">'.$row["extension"].'</div>'; ?></td>
		</tr>
		<tr>
			<td class="collapsing">URL</td>
			<td><?php echo '<a href="'.$row["url"].'">'.$row["url"].'</a>'; ?></td>
		</tr>
		<tr>
			<td class="collapsing">IP</td>
			<td><?php echo $row["ip"]; ?></td>
		</tr>
		<tr>
			<td class="collapsing">Mailer</td>
			<td><?php echo '<div class="nui label blue">'.$row["mailer"].'</div>'; ?></td>
		</tr>
		<tr>
			<td class="collapsing">Attachments</td>
			<td><?php echo implode("<br>", $row["attachments"]); ?></td>
		</tr>
		<tr>
			<td class="collapsing">Headers</td>
			<td>
				<?php
					foreach($row["headers"] as $k => $v){
						echo '<strong>'.$k."</strong>: ".(is_array($v) ? implode(", ", $v) : $v)."<br>";
					}
				?>
			</td>
		</tr>
	</tbody>
</table>