<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

ChronoPage::SaveSettings();

ChronoPage::ReadSettings();
?>
<form class="nui form" action="<?php echo $this->current_url; ?>" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
	<?php
		ChronoPage::SettingsHTML();
	?>

	<fieldset class="nui segment white bordered rounded">
		<legend class="nui bold large label grey rounded">Letters Settings</legend>
		<div class="equal fields">
			<?php new FormField(name: "settings[send_limit]", label: "Send Limit", value:10, hint:"The number of emails to send per send patch."); ?>
		</div>
	</fieldset>

	<fieldset class="nui segment white bordered rounded">
		<legend class="nui bold large label grey rounded">Logs Settings</legend>
		<div class="equal fields">
			<?php new FormField(name: "settings[logs_index_sort]", type:"select", label: "Sort logs by", options:[
				new Option(text:"ID ASC", value:"id asc"),
				new Option(text:"ID DESC", value:"id desc"),
				new Option(text:"Time ASC", value:"created asc"),
				new Option(text:"Time DESC", value:"created desc"),
			], hint:"The field to use for sorting logs list."); ?>
		</div>
	</fieldset>

	<fieldset class="nui segment white bordered rounded">
		<legend class="nui bold large label grey rounded">Layouts editor Settings</legend>
		<div class="equal fields">
			<?php new FormField(name: "settings[max_field_mode]", type:"select", label: "Increase max items", options:[
				new Option(text:"No", value:""),
				new Option(text:"Yes", value:"1"),
			], hint:"The maximum possible number of items per layout is dependent on the server's PHP setting max_input_vars, but this setting can bypass the limit without changing the server setting"); ?>
		</div>
	</fieldset>

	<fieldset class="nui segment white bordered rounded">
		<legend class="nui bold large label grey rounded">Validation Key</legend>
		<div class="equal fields">
			<?php new FormField(name: "settings[vkey]", label: "Your ChronoEngine.com validation key", hint:"The validation key is stored for convenience and can be cleared from the system if necessary."); ?>
		</div>
	</fieldset>

</form>