<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license: GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

if($this->isPost){
    if(!empty($this->data("user_id")) OR (!empty($this->data("name")) && !empty($this->data("email")))){
        ChronoPage::Save(CMSubscribersModel::instance());
    }else{
        ChronoSession::setFlash("error", Chrono::l("Error, you need to provide either an Email & Name OR a Joomla User ID"));
    }
}

$row =  CMSubscribersModel::instance()->Select(conditions:[['id', "=", $this->data("id")]], single: true);

$lists_rows = CMListsModel::instance()->Select();
$lists = [];
foreach($lists_rows as $list){
    $lists[] = new Option(text:$list["title"], value:$list["id"]);
}

$user_lists = [];
if(!empty($this->data("id"))){
    $sublists_rows = CMSubscribersListsModel::instance()->Select(conditions:[["subscriber_id", "=", $row["id"]]]);
    foreach($sublists_rows as $sublists_row){
        $user_lists[] = $sublists_row["list_id"];
    }
}
$row["lists"] = $user_lists;

ChronoApp::$instance->MergeData($row);
?>
<form class="nui form" action="<?php echo ChronoApp::$instance->current_url; ?>" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
	<?php
	$buttons = [];
	
	$buttons[] = new MenuButton(name: "save", title: "Save", icon: "floppy-disk", color: "blue");
	
	$title = "New Mailing Subscriber";
	if(!empty($row["id"])){
		$title = "<span class='nui smaller'>".$row["email"]."</span>";
	}
	$buttons[] = new MenuButton(name: "close", link: true, title: "Close", icon: "xmark", color: "red", url: "action=subscribers.index");
	
	new MenuBar(title: $title, buttons: $buttons);

	new FormField(name: "id", label: "ID", type: "hidden");
	?>

	<div class="equal fields">
		<?php new FormField(name: "email", label: "Email Address"); ?>
        <?php new FormField(name: "name", label: "Name"); ?>
		<?php new FormField(name: "user_id", label: "Joomla User ID", value:0); ?>
	</div>
    <div class="equal fields">
		<?php
			new FormField(name: "active", label: "Active", type: "select", options: [
				new Option(text: "Yes", value: "1"),
				new Option(text: "No", value: "0"),
			]);
		?>
        <?php
			new FormField(name: "confirmed", label: "Confirmed", type: "select", options: [
				new Option(text: "Yes", value: "1"),
				new Option(text: "No", value: "0"),
			]);
		?>
        <?php
			new FormField(name: "language", label: "Language", type: "select", options: [
				new Option(text: "en-GB", value: ""),
			]);
		?>
	</div>

    <?php new FormField(name: "lists", type:"select", label: "Lists", multiple: true, options:$lists, hint:"Select which Mail Lists to assign this subscriber to"); ?>

</form>