CREATE TABLE IF NOT EXISTS `#__chronog3_extensions` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`name` varchar(150) NOT NULL DEFAULT '',
	`enabled` tinyint(1) NOT NULL DEFAULT '0',
	`ordering` int(4) NOT NULL DEFAULT '0',
	`settings` text,
	PRIMARY KEY (`id`),
	KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `#__chronomails_logs` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`created` datetime NOT NULL,
	`subject` text NOT NULL,
	`recipients` text NOT NULL,
	`status` tinyint(1) NOT NULL DEFAULT 0,
	`body` longtext NOT NULL,
	`extension` varchar(50) NOT NULL,
	`mailer` varchar(10) NOT NULL,
	`headers` text NOT NULL,
	`attachments` text DEFAULT NULL,
	`ip` varchar(50) DEFAULT NULL,
	`url` text DEFAULT NULL,
	PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `#__chronomails_layouts` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`title` varchar(255) NOT NULL,
	`published` tinyint(1) NOT NULL DEFAULT 1,
	`elements` longtext NOT NULL,
	`template` longtext NOT NULL,
	`params` text DEFAULT NULL,
	PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `#__chronomails_letters` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`title` varchar(255) NOT NULL,
	`alias` varchar(255) NOT NULL,
	`published` tinyint(1) NOT NULL DEFAULT 1,
	`created` datetime DEFAULT NULL,
	`content` longtext NOT NULL,
	`lists` text DEFAULT NULL,
	`layout_id` int(11) NOT NULL DEFAULT 0,
	`params` text DEFAULT NULL,
	`send` tinyint(1) NOT NULL DEFAULT 0,
	`finished` int(11) NOT NULL DEFAULT 0,
	`last_sent` datetime DEFAULT NULL,
	PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `#__chronomails_lists` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`title` varchar(255) NOT NULL,
	`published` tinyint(1) NOT NULL DEFAULT 0,
	`description` text NOT NULL,
	`params` text DEFAULT NULL,
	PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `#__chronomails_subscribers` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`user_id` int(11) NOT NULL DEFAULT 0,
	`email` varchar(255) NOT NULL DEFAULT '',
	`name` varchar(255) NOT NULL DEFAULT '',
	`language` varchar(10) NOT NULL DEFAULT '',
	`created` datetime DEFAULT NULL,
	`ip` varchar(100) NOT NULL DEFAULT '',
	`active` tinyint(1) NOT NULL DEFAULT 1,
	`source` varchar(255) DEFAULT NULL,
	`confirmed` tinyint(4) NOT NULL DEFAULT 1,
	PRIMARY KEY (`id`),
	UNIQUE KEY `user_id_email` (`user_id`,`email`),
	KEY `email` (`email`),
	KEY `language` (`language`),
	KEY `active` (`active`),
	KEY `confirmed` (`confirmed`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `#__chronomails_subscribers_lists` (
	`subscriber_id` int(11) NOT NULL,
	`list_id` int(11) NOT NULL,
	PRIMARY KEY (`subscriber_id`,`list_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;