<?php
/**
* ChronoMails
* Copyright (c) 2025 ChronoEngine.com, All rights reserved.
* Author: (ChronoEngine.com Team)
* license:     GNU General Public License version 2 or later; see LICENSE.txt
* Visit http://www.ChronoEngine.com for regular updates and information.
**/
defined('_JEXEC') or die('Restricted access');

require_once(dirname(dirname(dirname(__DIR__))).DIRECTORY_SEPARATOR."administrator".DIRECTORY_SEPARATOR."components".DIRECTORY_SEPARATOR."com_chronomails".DIRECTORY_SEPARATOR."extension.php");

class ChronoMail extends Joomla\CMS\Mail\Mail
{
	var $_method = "";
	var $layout_id = "";

    public function send()
    {
		// $this->Priority

		// Joomla\CMS\Log\Log::add(json_encode($this), Joomla\CMS\Log\Log::INFO, 'send');

		$this->Mailer = $this->_method;
		$body = $this->Body;

		$extension = Joomla\CMS\Factory::getApplication()->input->get('option', '');
		$cm = ChronoApp::Instance("chronomails", "ChronoMails");

		if(empty($this->layout_id)){
			$layouts = CMLayoutsModel::instance()->Select(conditions:[['published', "=", 1]], order:'id desc');

			foreach($layouts as $layout){
				$layout["params"]["apply_extensions"] = isset($layout["params"]["apply_extensions"]) ? $layout["params"]["apply_extensions"] : [];
				if(in_array($extension, $layout["params"]["apply_extensions"])){
					if($this->ContentType == "text/plain"){
						$body = nl2br($body);
						$this->ContentType = "text/html";
					}
					$body = str_replace('{email:body}', $body, $layout["template"]);
					if(!$cm->validated(true) && !str_contains($body, 'Po'.'wer'.'ed b'.'y')){
						$body .= '<div style="text-align:center;font-weight:bold;font-size:1.5em;padding:1em;"><a href="https://www.chronoengine.com/">Po'.'wer'.'ed b'.'y Ch'.'ro'.'noM'.'ai'.'ls</a></div>';
					}
					
					break;
				}
			}
		}else{
			$layout = CMLayoutsModel::instance()->Select(conditions:[['id', "=", $this->layout_id]], single:true, order:'id desc');

			$layout["params"]["apply_extensions"] = isset($layout["params"]["apply_extensions"]) ? $layout["params"]["apply_extensions"] : [];
			
			if($this->ContentType == "text/plain"){
				$body = nl2br($body);
				$this->ContentType = "text/html";
			}
			$body = str_replace('{email:body}', $body, $layout["template"]);
			if(!$cm->validated(true) && !str_contains($body, 'Po'.'wer'.'ed b'.'y')){
				$body .= '<div style="text-align:center;font-weight:bold;font-size:1.5em;padding:1em;"><a href="https://www.chronoengine.com/">Po'.'wer'.'ed b'.'y Ch'.'ro'.'noM'.'ai'.'ls</a></div>';
			}
		}

        // Call the parent send method to send the email
        $status = parent::send();

		$log_extensions = !empty($cm->settings["log_extensions"]) ? $cm->settings["log_extensions"] : [];

		if(empty($log_extensions) OR in_array($extension, $log_extensions)){
			$logEntry = [
				'subject' => $this->Subject,
				'recipients' => $this->to,
				'body' => $body,
				'attachments' => $this->attachment,
				'created' => JFactory::getDate()->toSql(),
				'extension' => $extension,
				'status' => $status,
				'mailer' => $this->Mailer,
				'ip' => $_SERVER['REMOTE_ADDR'],
				'url' => $cm->current_url,
				'headers' => [
					"From" => $this->From,
					"FromName" => $this->FromName,
					"ReplyTo" => !empty($this->ReplyTo) ? array_values($this->ReplyTo)[0] : "",
					"ReplyToName" => !empty($this->ReplyTo) ? array_keys($this->ReplyTo)[0] : "",
					"CC" => $this->cc,
					"BCC" => $this->bcc,
					"ContentType" => $this->ContentType,
					"CharSet" => $this->CharSet,
				],
			];
	
			$result = CMLogsModel::instance()->Insert($logEntry);
		}

		return $status;
    }
}

class PlgSystemChronomails extends Joomla\CMS\Plugin\CMSPlugin{
	public function onAfterInitialise()
    {
		if(!class_exists("CMLettersModel")){
			return;
		}
        // Override the default mailer with our custom mailer
		$mail = new ChronoMail();
		$mail->_method = Joomla\CMS\Factory::getConfig()->get("mailer");
        Joomla\CMS\Factory::$mailer = $mail;

		$cm = ChronoApp::Instance("chronomails", "ChronoMails");

		$limit = Chrono::getVal($cm->settings, "send_limit", 10);

		$letters = CMLettersModel::instance()->Select(conditions:[['published', "=", 1], "AND", ["send", "=", "1"]], order:'id desc');
		foreach($letters as $letter){
			if(!empty($letter["send"]) && !empty($letter["lists"])){
				$finished = (int)$letter["finished"];
				// $subscribers = CMSubscribersModel::instance()->Select(conditions:[['SubList.list_id', "in", $letter["lists"]]], order:'Sub.id asc', limit:$limit, offset:$finished, alias:"Sub", joins:[
				// 	["type" => "right", "table" => "#__chronomails_subscribers_lists", "alias" => "SubList", "on" => "SubList.list_id = Sub.id"],
				// 	["type" => "left", "table" => "#__users", "alias" => "User", "on" => "User.id = Sub.user_id"],
				// ], fields:["Sub.id", "Sub.user_id", "Sub.email", "User.email"]);
				$subscribers = CMSubscribersListsModel::instance()->Select(conditions:[
					['SubList.list_id', "in", $letter["lists"]],
					"AND",
					['Sub.active', "=", 1],
					"AND",
					['Sub.confirmed', "=", 1],
				], 
				order:'SubList.subscriber_id asc', limit:$limit, offset:$finished, alias:"SubList", joins:[
					["type" => "left", "table" => "#__chronomails_subscribers", "alias" => "Sub", "on" => "SubList.subscriber_id = Sub.id"],
					["type" => "left", "table" => "#__users", "alias" => "User", "on" => "User.id = Sub.user_id"],
				], fields:["Sub.id", "Sub.user_id", "Sub.email", "User.email"]);
				Chrono::pr($subscribers);
				foreach($subscribers as $subscriber){
					$this->send($letter, !empty($subscriber["Sub.email"]) ? $subscriber["Sub.email"] : $subscriber["User.email"]);
				}

				if(count($subscribers) < $limit){
					$result = CMLettersModel::instance()->Update(["id" => $letter["id"], "send" => 0, "finished" => 0]);
				}else{
					$finished += $limit;
					$result = CMLettersModel::instance()->Update(["id" => $letter["id"], "finished" => $finished]);
				}
			}
		}
    }

	public function send($letter, $to){
		$mailer = ChronoApp::mailer();
		$config = ChronoApp::config();

		$from_email = !empty($letter["params"]["from"]) ? $letter["params"]["from"] : $config->get('mailfrom');
		$from_name = !empty($letter["params"]["fromname"]) ? $letter["params"]["fromname"] : $config->get('fromname');
		$reply_email = !empty($letter["params"]["reply"]) ? $letter["params"]["reply"] : null;
		$reply_name = !empty($letter["params"]["replyname"]) ? $letter["params"]["replyname"] : null;

		if(!empty($letter["layout_id"])){
			$mailer->layout_id = $letter["layout_id"];
		}

		$result = $mailer->sendMail(
			$from_email,
			$from_name,
			$to,
			$letter["title"],
			$letter["content"],
			!empty($letter["params"]["html"]),
			null,
			null,
			!empty(trim($letter["params"]["attachments"])) ? explode("\n", trim($letter["params"]["attachments"])) : null,
			$reply_email,
			$reply_name
		);
	}
}